#!/usr/bin/perl -w
# File: HashTree.pm
#
# Created: Sat Mar 30 12:41:06 2002
## $Id: benchmark_Hash.pl,v 1.3 2002/07/08 15:47:38 igor Exp $
# Authors: Igor Vlasenko and Alexander V. Strelets 

use lib "./lib";
use lib "./blib/arch";
use Data::Array2ArrayMap::Hash::Tree;
use Data::Array2ArrayMap::Hash::XSTree;
use Data::Array2ArrayMap::Hash::MultiKey;
use Carp;
use strict;
use Benchmark;


my $N=50000;
my $c;
print "\nSolid Hash testing\n";
    $c=Data::Array2ArrayMap::Hash::MultiKey->new();
print "set testing\n";
    time_set($c);
print "get testing\n";
    time_get($c);
print "path testing\n";
    time_path($c);


print("\nTree Hash testing\n");
    $c=Data::Array2ArrayMap::Hash::Tree->new();
print "set testing\n";
    time_set($c);
print "get testing\n";
    time_get($c);
print "path testing\n";
    time_path($c);

print("\nXS Tree Hash testing\n");
    $c=Data::Array2ArrayMap::Hash::XSTree->new();
print "set testing\n";
    time_set($c);
print "get testing\n";
    time_get($c);
print "path testing\n";
    time_path($c);



sub time_set{
    my $c=shift;
    my $i=0;
    my $t0= new Benchmark;
    for ($i=1; $i<=$N; $i++){
	$c->set([1],[1]);
    }
    my $t1=new Benchmark;
    my $td=timediff($t1,$t0);
    print "Set for  1 arg  takes ",timestr($td),"\n";



    $t0=new Benchmark;
    for (my $i=1;$i<=$N; $i++){
	$c->set([2,1],[1]);
    }
    $t1=new Benchmark;
    $td=timediff($t1,$t0);
    print "Set for  2 args takes ",timestr($td),"\n";


    $t0=new Benchmark;
    for (my $i=1;$i<=$N; $i++){
	$c->set([4,1,1,1,1,1,1,1,1,1],[1]);
    }
    $t1=new Benchmark;
    $td=timediff($t1,$t0);
    print "Set for 10 args takes ",timestr($td),"\n";

}

sub time_get{

    my $c=shift;
    my $i=0;
    my @a;
    my $t0= new Benchmark;
    for ($i=1; $i<=$N; $i++){
	@a=$c->get([1]);
    }
    my $t1=new Benchmark;
    my $td=timediff($t1,$t0);
    print "Get for  1 arg  takes ",timestr($td),"\n";

    $t0=new Benchmark;
    for (my $i=1;$i<=$N; $i++){
	@a=$c->get([2,1]);
    }
    $t1=new Benchmark;
    $td=timediff($t1,$t0);
    print "Get for  2 args takes ",timestr($td),"\n";


    $t0=new Benchmark;
    for (my $i=1;$i<=$N; $i++){
	@a=$c->get([4,1,1,1,1,1,1,1,1,1]);
    }
    $t1=new Benchmark;
    $td=timediff($t1,$t0);
    print "Get for 10 args takes ",timestr($td),"\n";

}

sub time_path{
    my $c=shift;
    my $i=0;
    my @a;
    my $t0= new Benchmark;
    for ($i=1; $i<=$N; $i++){
	@a=$c->paths_all();
    }
    my $t1=new Benchmark;
    my $td=timediff($t1,$t0);
    print "Subpath takes ",timestr($td),"\n";

}


